package org.charter.jmlunitng;

public class BinSearch {

  /*@ public normal_behavior
        requires array != null;
        requires (* Fill in here *);
        ensures \result >= 0;

      also public normal_behavior
        requires array != null;
        requires (\forall int i; i>=0 && i<array.length; array[i] != target);
        ensures \result == -1;
    @*/
  public int search( int[] array, int target ) {

    int low = 0; // The start of the search region
    int high = array.length; // The end of the search region
    int mid;

    // Something left to search and target not yet found
    while ( low < high ) {
      mid = (low + high) / 2 ; // Location of the mid      
      // Determine whether the target is smaller than, greater than,
      // or equal to the mid element
      if ( target < array[mid]) {
        // Target is smaller; must be in left half
        high = mid - 1;
      } else if ( target > array[mid] ) {
        // Target is larger; must be in right half
        low = mid + 1;
      } else {
        // Found it!!
        return mid;
      }
    }
    return -1; // nothing found
  }

}
